/*
 * Copyright (C) Sapphirecode - All Rights Reserved
 * This file is part of Auth-Server-Helper which is released under MIT.
 * See file 'LICENSE' for full license details.
 * Created by Timo Hocker <timo@scode.ovh>, August 2022
 */

export interface Key {
  key: string;
  valid_until: number;
}

export interface LabelledKey extends Key {
  index: string;
}

export interface KeyPair {
  private_key?: Key;
  public_key: Key;
}

export type KeyStoreData = Record<string, KeyPair>;
export type KeyStoreExport = LabelledKey[];
